<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.transport.mgt.ui.TransportAdminClient" %>
<%@page import="org.wso2.carbon.transport.mgt.ui.types.carbon.TransportParameter"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Map" %>

<script type="text/javascript" src="global-params.js"></script>
<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="../carbon/admin/js/main.js"></script>

<%
String backendServerURL;
ConfigurationContext configContext;
String cookie;
TransportAdminClient client;
TransportParameter[] transportInData;
TransportParameter[] transportOutData;
Map<String, String[]> map;
TransportParameter param;
List<TransportParameter> transportInDataList;
List<TransportParameter> transportOutDataList;

backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
configContext = (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
client = new TransportAdminClient(cookie, backendServerURL,configContext);

map = request.getParameterMap();
transportInDataList = new ArrayList<TransportParameter>();
transportOutDataList = new ArrayList<TransportParameter>();

String paramValue;

final String TRANSPORT_SENDER_SUFFIX = "_trpSender";
final String TRANSPORT_NAME = "_transport";
final String SERVICE_NAME = "_service";

String transport = null;
String serviceName = null;
boolean updateSender = false;

if (map.containsKey(TRANSPORT_SENDER_SUFFIX)) {
    updateSender = true;
    map.remove(TRANSPORT_SENDER_SUFFIX);
}

if (map.containsKey(TRANSPORT_NAME)) {
    transport = map.get(TRANSPORT_NAME)[0].trim();
    map.remove(TRANSPORT_NAME);
}

if (map.containsKey(SERVICE_NAME)) {
    serviceName = map.get(SERVICE_NAME)[0].trim();
    map.remove(SERVICE_NAME);
}

for (String key : map.keySet()) {
    if (key.endsWith("_chk")) {
        continue;
    }

    paramValue = map.get(key)[0].trim();
    param = new TransportParameter();
    param.setName(key);
    param.setValue(paramValue);
    if (paramValue.startsWith("<")) {
        param.setParamElement(paramValue);
    }

    if (updateSender) {
        transportOutDataList.add(param);
    } else {
        transportInDataList.add(param);
    }
}


try {
    if (serviceName == null) {
        if (!updateSender) {
            transportInData = transportInDataList.toArray(new TransportParameter[transportInDataList.size()]);
            client.updateGloballyDefinedInParameters(transport, transportInData);
        } else {
            transportOutData = transportOutDataList.toArray(new TransportParameter[transportOutDataList.size()]);
            client.updateGloballyDefinedOutParameters(transport, transportOutData);
        }

        %>
             <script type="text/javascript">
                    location.href = '../transport-mgt/index.jsp';
            </script>

        <%

    } else {
        if (!updateSender) {
            transportInData = transportInDataList.toArray(new TransportParameter[transportInDataList.size()]);
            client.updateServiceSpecificInParameters(transport, serviceName, transportInData);
        } else {
            transportOutData = transportOutDataList.toArray(new TransportParameter[transportOutDataList.size()]);
            client.updateServiceSpecificOutParameters(transport, serviceName, transportOutData);
        }

        %>
            <script type="text/javascript">
                    location.href = '../transport-mgt/service_transport.jsp?serviceName=<%=serviceName%>';
            </script>
        <%
    }

%>

<%
} catch (Exception e) {
	 CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
 %>
	<script type="text/javascript">
	    location.href = "../admin/error.jsp";
	</script>
<%
	return;
}
%>